{#-#####################################################################
 # Template for /etc/network/interfaces
  ###################################################################-#}
{#-=====================================================================
 # Imports
 #===================================================================-#}
{%- import "common.j2"                      as config   with context -%}
{%- import "ifupdown/inc/helpers.j2"        as helpers  with context -%}
{%- import "ifupdown/inc/stanza_common.j2"  as common   with context -%}
{%- import "ifupdown/inc/stanza_allow.j2"   as allow    with context -%}
{%- import "ifupdown/inc/stanza_inet.j2"    as inet     with context -%}
{%- import "ifupdown/inc/stanza_inet6.j2"   as inet6    with context -%}
{%- import "ifupdown/inc/stanza.j2"         as iface    with context -%}

{#-=====================================================================
 # Render
 # ---------------------------------------------------------------------
 # Render the configuration of all defined interfaces.
 #===================================================================-#}
{%- macro render(indexes) -%}

  {{ '#' ~ ansible_managed ~ "\n\n" }}

  {#- Loopback is mandatory -#}
  {{
    'auto lo' ~ "\n"
    'iface lo inet loopback' ~ '\n\n'
  }}

  {#- Render adapter interfaces first -#}
  {%- for uid,interface in indexes['valid_interfaces'].items()
       if interface['type'] == 'adapter'
  -%}
    {{ iface.render(interface, indexes) }}
  {%- endfor -%}

  {#- Render bonding interfaces after adapters -#}
  {%- for uid,interface in indexes['valid_interfaces'].items()
       if interface['type'] == 'bond'
  -%}
    {{ iface.render(interface, indexes) }}
  {%- endfor -%}

  {#- Render vlan interfaces after bonds -#}
  {%- for uid,interface in indexes['valid_interfaces'].items()
       if interface['type'] == 'vlan'
  -%}
    {{ iface.render(interface, indexes) }}
  {%- endfor -%}

  {#- Render bridge interfaces after vlans -#}
  {%- for uid,interface in indexes['valid_interfaces'].items()
       if interface['type'] == 'bridge'
  -%}
    {{ iface.render(interface, indexes) }}
  {%- endfor -%}
{%- endmacro -%}

{{ render(role__sys_net_interfaces__indexes) }}
